-- KikiRools Panel


WinItem = class(Turbine.UI.Lotro.Window);


function WinItem:Constructor(profile)
	Turbine.UI.Lotro.Window.Constructor(self)
	self:SetText(gLang.WINTITLE);
	self:SetMouseVisible(false);
	self:SetSize(320,100);
	self:SetVisible(false);

	-- constantes diverses
	self.font = Turbine.UI.Lotro.Font.Verdana12;
	self.fontColor = Turbine.UI.Color(1,1,1)
	
	-- Recupere les donnes associes
	self.settingsName = profile;
	self.settings = Kiki.Commons.Settings(profile, { top=0; left=0; objId={}; } );
	
	-- Init le tableau des objets si besoin (on conserve le prcdent ^^)
	if self.settings.objId==nil then
		self.settings.objId={};
	end
	
	-- Stocke dans le settings les parametres de jeu.. pour avoir la lsite dans le settings !!
	self.settings.Categories = Turbine.Gameplay.ItemCategory;
	self.settings.Durability = Turbine.Gameplay.ItemDurability;
	self.settings.Quality = Turbine.Gameplay.ItemQuality;

	-- tracking de la position
	self.PositionChanged = function (sender,args)
		self.settings.top = self:GetTop();
		self.settings.left = self:GetLeft();
	end
	
	-- Positionne sur l'ecran
	self:SetPosition(self.settings.left,self.settings.top);

	-- Force le positionne sur l'ecran
	Kiki.Commons.Onscreen(self);

	local top = 50;
	local left = 15;
	local c;
	
	-- Zone de saisie de l'identifiant d'objet
	c = Turbine.UI.Lotro.TextBox();
	c:SetParent(self);
	c:SetSize(100,20);
	c:SetPosition(left,top);
	c:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	c:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	c:SetMultiline(false);
	self.input = c;
	self.lastText="";
	-- Lorsque le contenu change, on tente la mise en place du quickslot et de l'info
	self.input.TextChanged = function()
		local text = self.input:GetText() ;
		if text ~= self.lastText then
			-- nouveau texte, on le mmorise...
			self.lastText = text;
			-- On tente le tip !
			self:Show(text);
		end
	end
		
	left=left+c:GetWidth()+10;

	-- Positionne le texte d'ID (le bouton)
	c = Turbine.UI.Lotro.GoldButton();
	c:SetSize(130,20);
	c:SetVisible(true);	        
	c:SetParent(self);
	c:SetPosition(left, top);
	c:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	c:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	c:SetText("...");
	self.id=c;
	self.id.Click=function()
		self.input:SetText("");
		self.input:Focus();
	end	
	
	left=left+c:GetWidth()+10;

	-- Positionne le quickslot
	c = Turbine.UI.Lotro.Quickslot();
	c:SetSize(35,35);
	c:SetVisible(true);	        
    c:SetAllowDrop(false); 
    c:SetEnabled(false);	
	c:SetParent(self);
	c:SetPosition(left, top-7);
	self.qs=c;
	
	left=left+c:GetWidth()+10;

	-- Quickslot pour le scan	
	self.qsScan = Turbine.UI.Lotro.Quickslot();
	
end

-- Construction d'un shortcut d'Item
makesc = function(hex,qs)
	local sc = Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Item , string.format('0x0000000000000000,0x%s', hex ));
	-- Le SetShortCut ne fontionne pas si l'item est invalide !
	qs:SetShortcut(sc);
	return sc;
end

function WinItem:Show(str)
	-- Conversion en hexa de l'identifiant...
	local id = tonumber(str);
	if id ~= nil then
		-- nombre valide !
		local hex = string.format("%X",id);
    	local rc, sc = pcall(makesc, hex,self.qs);
	    if rc==true then
			self.qs.MouseDown=function(s,a)
				-- hack to prevent real item from being consumed by a click
				self.qs:SetShortcut(nil);
				self.qs:SetShortcut(sc);
			end	
			self.qs.DragDrop=function()
			end
			self.qs:SetVisible(true);
			-- Positionne le texte du bouton, et active le bouton
		    self.id:SetText(string.format("<Examine:IIDDID:0x0000000000000000:0x%s>ID:%s<\Examine>",hex,id));
			self.id:SetEnabled(true);
			return;
		end
	end
	-- Si on arrive ici, c'est qu'il y a un soucis !!!!
	-- alors on passe le bouton en disable
	self.id:SetText("Id invalide");
	self.id:SetEnabled(false);
	-- Annulation du shortcut
	self.qs:SetVisible(false);
end

-- Tente de creer l'item et si ok, le stocke dans le settings
function WinItem:TryThisItem(i)
	-- Convertit la valeur en hexa
	local hex = string.format("%08X",i);
	-- Construction du shortcut depuis un id d'item
	local rc, sc = pcall(makesc, hex, self.qsScan);
	-- Si shortcut ok, l'item existe !
	if rc ~= true then return false; end
	-- le shortcut a pu etre cre !!
	-- On recupere l'iteminfo !
	local ii = sc:GetItem():GetItemInfo();
	-- Kiki.Commons.Trace("getname="..ii:GetName());
	-- Ajoute les infos de l'objet dans la DB

	-- Si le NAME commence par "<string", le truc est  ignorer !
	local o = {
		Name = ii:GetName();
		NamePlural= ii:GetNameWithQuantity(2);
		BackGroundImageId = ii:GetBackgroundImageID();
		Category = ii:GetCategory();
		Description = ii:GetDescription();
		Durability = ii:GetDurability();
		IconImageId = ii:GetIconImageID();
		MaxQuantity = ii:GetMaxQuantity();
		MaxStackSize = ii:GetMaxStackSize();
		Quality = ii:GetQuality();
		QualityImageId = ii:GetQualityImageID();
		ShadowImageId = ii:GetShadowImageID();
		UnderlayImageId = ii:GetUnderlayImageID();
		Magic = ii:IsMagic();
		IsUnique = ii:IsUnique();
		
	};
	-- stockage !!
	self.settings.scannedObjects[hex] = o;
	return true;
end 

-- Fonction de balayage partiel (limit a 500 objets)
function WinItem:ScanTurn()
	local c = 0;
	while self.scanCurr <= self.scanTo and c < 100 do
		if self:TryThisItem(self.scanCurr) then
			self.scanFound = self.scanFound+1;
		end
		self.scanCurr = self.scanCurr+1;
		c = c + 1;
	end
end

-- Update : utilis pour les scan d'objets
function WinItem:Update( sender, args )
	if self.scanCurr <= self.scanTo then
		Kiki.Commons.Trace("Scan In progress:".. self.scanCurr);
		self:ScanTurn();
	else
		-- Arret du traitement sur refresh UI
		self:SetWantsUpdates( false ); 
		Kiki.Commons.Trace("Scan Termine:".. self.scanFrom.."-".. self.scanTo-1 .." found:"..self.scanFound.."\n<rgb=#FF0000>Faire un /item save pour sauvegarder dans le fichier (c'est TRES long ^^)</rgb>");
	end
end

function WinItem:ScanGame(d,f)
	if self.settings.scannedObjects == nil then
		self.settings.scannedObjects = {};
	end
	self.scanFrom = d;
	self.scanTo = f;
	self.scanCurr = d;
	self.scanFound = 0;
	-- Maintenant, c'est lors des update de l'UI que ca se passe ^^
	self:SetWantsUpdates( true ); 
end


function WinItem:AddReference(hex,text)
	-- Pour stockage des elements singuliers et pluriels car ils diffrents dans le libell
	if string.find(text,"(",1,true) then
		-- plusieurs objets
		self.settings.objId[hex.."-n-"..gLanguage]=text;
	else
		-- un seul objet
		self.settings.objId[hex.."-1-"..gLanguage]=text;
	end
	Kiki.Commons.Trace(gLang.OK.." "..hex..":=<rgb=#00FF00>"..text.."</rgb>");
end

function WinItem:ClearItems()
	self.settings.objId={};
	self.settings.scannedObjects={}
	Kiki.Commons.Trace(gLang.CLEARED);
end
function WinItem:SaveItems()
	self.settings:Save(self.settingsName);
	Kiki.Commons.Trace(gLang.SAVED);
end

function WinItem:Unload()
	self:SaveItems();
end


wItem = WinItem(gPluginName.."_panel"); 


